class {:autocontracts} Account
{
  var balance: int;

  constructor(b:nat)
  ensures Valid() && balance==b
  {
      balance := b;
  }
  method Withdraw(val: int)
    requires balance >= 0 && balance >= val;
    ensures Valid() && balance == old(balance) - val;
    modifies this;
{
balance := balance - val;
}
  method AddCredit (val: int)
    requires val >= 0;
    requires Valid();
    ensures balance >= 0 &&  balance == old(balance) + val;
    modifies this;
  {
     balance := balance + val;
}
  function Valid(): bool
       reads this;
{
balance >= 0
} 

}
method Main() {
var a := new Account(3);
a.AddCredit(5);
assert a.balance > 4;
a.Withdraw(8);
}
 