type T = int // to allow doing new T[capacity], but can be other type 
 
class Stack
{
    const elems: array<T>; 
    var size : nat; // used size
    var capacity: nat;
    constructor (cap: nat)
    {
        elems := new T[cap];
        capacity := cap;
        size := 0; 
    }
 
    predicate method {:verify false} isEmpty()
    {
        size == 0
    }
 
    predicate method {:verify false} isFull()
    {
        size == elems.Length
    }
 
    method {:verify false} push(x : T)
    {
        elems[size] := x;
        size := size + 1;
    }
 
    function method {:verify false} top(): T
    {
         elems[size-1]
    }
    
    method {:verify false} pop() 
    {
         size := size-1;
    }
}
 
// A simple test case.
method {:verify false} Main()
{
    var s := new Stack(3);
    assert s.isEmpty();
    s.push(1);
    s.push(2);
    s.push(3);
    assert s.top() == 3;
    assert s.isFull();
    s.pop();
    assert s.top() == 2;
    print "top = ", s.top(), " \n";
}
